
##########################
## Datova cast
##########################

VERSION = "1.0.0"
VULN = """
int main(void)
{
     // Created by Babca %(name)s v. %(version)s
     int (*func)();
     func = (int (*)()) shellcode;
     (*func)();
     return;
}
""" 

HELP="""
%(name)s [-x dec] -i input_file [-o output_file start_str end_str]

Verze %(version)s. Created by Babca.
            www.soom.cz

-x          Vytvoreni sifrovane podoby, parametr udava v dec.
            hodnotu pro funkci xor. (nepovinny)           
-i          Parametr pro vstupni soubor. (povinny)
-o          Parametr pro vystupni soubor. (nepovinny)
start_str   Retezec znacici zacatek shellcodu. (nepovinny)
end_str     Retezec znacici konec shellcodu. (nepovinny)
            Standartne pouzity 'Zacatek kodu:' a '<-Konec kodu'

example:
    %(name)s -i shellcode.exe
    %(name)s -i shellcode.exe -o vuln.c START: KONEC
    %(name)s -x 28 -i shellcode.exe -o code.asm
"""

ASM_HEAD="""; /*******************************************************************
; * Vytvoreno pomoci %(name)s verze %(version)s by Babca
; *
; * Decode shellcode by XOR
; *
; * Zkompilovani:
; *     - ml /c /coff /Cp xxx.asm
; *     - link /subsystem:windows /section:.text,w xxx.obj
; *
; * babcca [at] seznam.cz
; *
; * 
; \*******************************************************************
"""

ASM_CODE="""%(asm_head)s
.386
.model flat, stdcall
option casemap :none

.code
db  "Zacatek kodu:", 0, 0   ; - Informace pro nas, abychom vedeli, kde je shellcod

start:
  jmp Sifra                 ; - Ziskej zakodovany kod

MamSifru:                      	
  pop eax                   ; - Uloz adresu do EAX     	 

Dekoduj:                    	
  xor byte ptr [eax], %(xor)s   ; - Dekoduj hodnotou %(xor)s   	 
  inc eax                   	; - Prejdi na dalsi znak (pricti 1 k adrese v EAX) 
  cmp dword ptr [eax], '%(string_rev)s' ; - Jsme uz na konci zasifrovaneho kodu?  	
  jne Dekoduj                   ; - Jestli ne skoc na navesti dekoduj
  jmp StartKodu		        ; - Pokud ano spust nas kod

Sifra:                        	; - Zase trik pro ziskani adresy
  call MamSifru                	 

StartKodu:
    ;****************************
    ;* Nas zakodovany kod
    ;****************************
    %(code)s
    
    db '%(string)s'     ; - Abychm poznaly, jestli mame porad dekodovat                 	
				
db "<-Konec kodu!",0,0  ; - Zde konci nas shellkod
end start
"""


#########################
## Cast s kodem
#########################

class ShellCode:
    def __init__(self, firststr="Zacatek kodu:\0\0", laststr="<-Konec kodu"):
        self.firststr = firststr
        self.laststr  = laststr
        self.len      = len(self.firststr)
        self.isexe    = False
        self.text     = ""
        self.code    = "char shellcode[] ="
        self.openname = ""

    def openFile(self, name, mode="rb"):
        self.openname = name
        try:
            code = open(self.openname, mode)
            if code.read(2) == "MZ":
                self.isexe = True
            self.text = code.read()
            code.close()
        except IOError:
            return -1

    def findCode(self):
        if self.isexe:
            firstindex = self.text.find(self.firststr) + self.len
            lastindex  = self.text.find(self.laststr)
            self.text  = self.text[firstindex:lastindex]

        if lastindex == -1 or firstindex == self.len-1:
            return -1

    def createCode(self, lenght=15):
        for i in xrange(0,len(self.text)):
            if not i % lenght:
                if not i:
                    self.code = self.code + '\n\t\t "\\x%02X' % ord(self.text[i])
                else:
                    self.code = self.code + '"\n\t\t "\\x%02X' % ord(self.text[i])
            else:
                self.code = self.code + '\\x%02X' % ord(self.text[i])
        self.code = self.code + '";\n' + VULN % par

    def saveCode(self, filename="", suffix="c", mode="w"):
        if not filename:
            filename = "new_" + self.openname[0:len(self.openname)-3] + suffix
        try:
            code = open(filename, mode)
            code.write(self.code)
            code.close()
        except IOError:
            return -1


class XorCode(ShellCode):
    def __init__(self, firststr="Zacatek kodu:\0\0", laststr="<-Konec kodu"):
        ShellCode.__init__(self, firststr, laststr)
        self.code = ""
        self.id_str = "ende"
        self.xor=0x00

    def createAsmCode(self, xor=0x80, lenght=15):
        self.xor=xor
        for i in xrange(0,len(self.text)):
            if not i % lenght:
                if not i:
                    self.code = self.code + 'db %d' % self.xorcode(self.text[i], self.xor)
                else:
                    self.code = self.code + '\n    db %d' % self.xorcode(self.text[i], self.xor)
            else:
                self.code = self.code + ', %d' % self.xorcode(self.text[i], self.xor)
        data = {
                    "asm_head" : ASM_HEAD % par, "xor" : ("%d" % self.xor),
                    "string": self.id_str, "string_rev": self.reverse(self.id_str),
                    "code" : self.code}

        self.code = ASM_CODE % data

    def xorcode(self, char, xor=0x80):
        return (ord(char)^xor)

    def setidstr(self, id_str):
        if len(id_str) == 4:
            self.id_str = id_str
            
    def reverse(self, string):
        string = list(string)
        string.reverse()
        return "".join(string)
            

        

        
##########################
## Hlavni kod programu
##########################
        
if __name__ == "__main__":
    import sys, getopt, os
    
    par = {"name" : sys.argv[0].split(os.sep)[-1], "version" : VERSION}
    
    if len(sys.argv) > 1:
        try:
            opt, arg = getopt.getopt(sys.argv[1:], "x:i:o:")
        except getopt.GetoptError:
            print HELP % par
            sys.exit(0)
        
        opt = dict(opt)
        #print opt

        if "-x" in opt.keys():
            if len(arg) == 2:
                XC = XorCode(arg[0], arg[1])
            else:
                XC = XorCode()
            if XC.openFile(opt["-i"]) == -1:
                print "[-] Nemohu otevrit soubor %s" % opt["-i"]
            else:
                print "[+] Vyhledavam shellcode"
                if XC.findCode() == -1:
                    print "[-] Shellcode nebyl nalezen"
                else:
                    print "[+] Vytvarim kod"
                    XC.createAsmCode(int(opt["-x"]))                       
                    if "-o" in opt.keys() and opt["-o"][0] != "-":
                        print "[+] Ukladam kod do %s" % opt["-o"]
                        if XC.saveCode(opt["-o"], "asm") == -1:
                            print "[-] Nemohu zapsat do %s" % opt["-o"]
                    else:
                        print "[+] Ukladam kod do %s" % ("new_"+opt["-i"][0:len(opt["-i"])-3] + "asm")
                        if XC.saveCode("", "asm") == -1:
                            print "[-] Nemohu zapsat do %s" % ("new_"+opt["-i"][0:len(opt["-i"])-3] + "asm")

        else:
            if "-i" in opt.keys() and opt["-i"][0] != "-":
                if len(arg) == 2:
                    SC = ShellCode(arg[0], arg[1])
                else:
                    SC = ShellCode()
                    
                if SC.openFile(opt["-i"]) == -1:
                    print "[-] Nemohu otevrit soubor %s" % opt["-i"]
                else:
                    print "[+] Vyhledavam shellcode"
                    if SC.findCode() == -1:
                        print "[-] Shellcode nebyl nalezen"
                    else:
                        print "[+] Vytvarim kod"
                        SC.createCode()                       
                        if "-o" in opt.keys() and opt["-o"][0] != "-":
                            print "[+] Ukladam kod do %s" % opt["-o"]
                            if SC.saveCode(opt["-o"]) == -1:
                                print "[-] Nemohu zapsat do %s" % opt["-o"]
                        else:
                            print "[+] Ukladam kod do %s" % ("new_"+opt["-i"][0:len(opt["-i"])-3] + "c")
                            if SC.saveCode() == -1:
                                print "[-] Nemohu zapsat do %s" % ("new_"+opt["-i"][0:len(opt["-i"])-3] + "c")
                    
        
    else:
        print HELP % par
        
        
